package com.hzya.frame;

import com.hzya.frame.nifiapi.model.joincreateprocessorandupdateparam.CreateProcessorAndUpdateParamJoin;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.Component19;
import com.hzya.frame.nifiapi.model.joingetallcontrollerservice.ControllerServices19;
import com.hzya.frame.nifiapi.model.resultNeedModifyController.PortFilterResult;
import com.hzya.frame.nifiapi.model.resultprocessorsinfo.Component16;
import com.hzya.frame.nifiapi.model.resultprocessorsinfo.Config16;
import com.hzya.frame.nifiapi.operation.INifiAppOperation;
import com.hzya.frame.nifiapi.operation.INifiBaseOperation;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame
 * @Project：fw-nifi
 * @name：TestINifiBaseOperation
 * @Date：2025/5/22 17:02
 * @Filename：TestINifiBaseOperation
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = {WebappApplication.class})
public class TestINifiBaseOperation {

    @Autowired
    private INifiBaseOperation iNifiBaseOperation;

    @Autowired
    private INifiAppOperation iNifiAppOperation;

    @Test
    public void testGetNeedModifyControllerServicesByProcessGroup() throws Exception {
        try {
            List<ControllerServices19> needModifyControllerServicesByProcessGroup = iNifiBaseOperation.getNeedModifyControllerServicesByProcessGroup("4143d803-0196-1000-968f-b06f55b43a3f");
            System.out.println(needModifyControllerServicesByProcessGroup.size());
            ControllerServices19 controllerServices19 = needModifyControllerServicesByProcessGroup.get(0);
            Component19 component = controllerServices19.getComponent();
            System.out.println(component.getName());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testGetNeedModifyControllerServicesByProcessGroup2() throws Exception {
        try {
            ControllerServices19 czfJwnb9sb = iNifiBaseOperation.getNeedModifyControllerServicesByProcessGroup("4143d803-0196-1000-968f-b06f55b43a3f", "CZFJwnb9sb");
            if (czfJwnb9sb != null && czfJwnb9sb.getComponent() != null) {
                Component19 component = czfJwnb9sb.getComponent();
                String name = component.getName();
                System.out.println(name);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testGetNeedModifyControllerRelationshipByProcessGroup() throws Exception {
        try {
            PortFilterResult needModifyControllerRelationshipByProcessGroup = iNifiBaseOperation.getNeedModifyControllerRelationshipByProcessGroup("41437b87-0196-1000-6951-50e41e75c0da", "f5228bc8-0360-41eb-a640-9f4df953937c");
            System.out.println(needModifyControllerRelationshipByProcessGroup);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testCopyProcessor() throws Exception {
        try {
            String targetProcessorId = "7f70897a-0196-1000-241a-3a7cdf5bf521";
            String parentProcessGroupId = "76e23100-ad84-1aab-4447-b9ee936ee7d5";
            String copyTargetProcessGroupId = "76e23115-ad84-1aab-7630-21c76aa3973d";
            String s = iNifiBaseOperation.copyProcessor(targetProcessorId, parentProcessGroupId, copyTargetProcessGroupId);
            System.out.println("新处理器id：" + s);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testCreateProcessorAndUpdateParam() {
        try {
            Map<String, String> properties = new HashMap<>();
            properties.put("File Size", "1B");
            properties.put("Batch Size", "2");
            properties.put("Data Format", "Binary");
            properties.put("Unique FlowFiles", "true");
            properties.put("character-set", "GBK");

            Config16 config16 = new Config16();
            config16.setProperties(properties);

            Component16 component16 = new Component16();
            component16.setName("修改处理器名称2");
            component16.setConfig(config16);

            CreateProcessorAndUpdateParamJoin createProcessorAndUpdateParamJoin = new CreateProcessorAndUpdateParamJoin();
            createProcessorAndUpdateParamJoin.setComponent(component16);
            createProcessorAndUpdateParamJoin.setTargetProcessorId("7f70897a-0196-1000-241a-3a7cdf5bf521");
            createProcessorAndUpdateParamJoin.setCopyTargetProcessGroupId("76e23115-ad84-1aab-7630-21c76aa3973d");
            createProcessorAndUpdateParamJoin.setParentProcessGroupId("76e23100-ad84-1aab-4447-b9ee936ee7d5");

            String processorAndUpdateParam = iNifiAppOperation.createProcessorAndUpdateParam(createProcessorAndUpdateParamJoin);
            System.out.println("新处理器id：" + processorAndUpdateParam);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testgGetFindStateClearMarkProcessor() throws Exception {
        try {
            iNifiBaseOperation.getFindStateClearMarkProcessor("41437b87-0196-1000-6951-50e41e75c0da", "接口状态清理标记");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void testBatchEnabledControllerServices() throws Exception {
        try {
            iNifiBaseOperation.batchEnabledControllerServices("4143d803-0196-1000-968f-b06f55b43a3f", "xxxx");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
