package com.hzya.frame.nifiapi.operation;

import com.hzya.frame.nifiapi.model.joincreateoracleapp.CreateAppInstanceJoin;
import com.hzya.frame.nifiapi.model.joincreateprocessorandupdateparam.CreateProcessorAndUpdateParamJoin;
import com.hzya.frame.nifiapi.model.resultcreateoracleapp.CreateAppInstanceResult;

/**
 * NiFi应用实例化业务操作接口
 *
 * @Author：liuyang
 * @Package：com.hzya.frame.nifiapi.operation
 * @Project：fw-nifi
 * @name：NifiOperation
 * @Date：2025/5/21 17:05
 * @Filename：NifiOperation
 */
public interface INifiAppOperation {
    /**
     * 完成应用创建并实例化
     * 主要包含一系列nifi接口调用操作，其他应用开发封转类以此类推
     * 1.创建nifi片段
     * 2.把片段实例化
     * 3.修改nifi控制器
     * 4.新建上下文环境参数
     * 5.绑定上下文环境参数到流程组
     * 6.激活当前流程组内的所有控制器服务
     *
     * @param createOracleApp 封装创建Oracle应用所需要的入参
     */
    CreateAppInstanceResult createAppContext(CreateAppInstanceJoin createOracleApp) throws Exception;

    /**
     * Mysql应用创建并实例化
     *
     * @param createMysqlApp 封装创建Mysql应用所需要的入参
     */
//    void createMysqlApp(CreateMysqlApp createMysqlApp) throws Exception;

    /**
     * 新建处理器实例，先拷贝，再接收修改参数
     *
     * @param createProcessorAndUpdateParamJoin 封转创建处理器所需要的参数
     */
    String createProcessorAndUpdateParam(CreateProcessorAndUpdateParamJoin createProcessorAndUpdateParamJoin) throws Exception;
}
