package com.hzya.frame.nifilog.entity;

import com.hzya.frame.web.entity.BaseEntity;
import lombok.Data;

import java.util.List;

/**
 * NiFi 日志事件表，按天拆分(LoggingEvent20250430)实体类
 *
 * @author xiang2lin
 * @since 2025-05-20 09:37:50
 */
@Data
public class LoggingEvent20250430Entity extends BaseEntity {
    /**
     * 日志时间戳（毫秒）
     */
    private Long timestmp;
    /**
     * 格式化后的日志消息
     */
    private String formattedMessage;
    /**
     * 日志记录器的名称
     */
    private String loggerName;
    /**
     * 日志级别（如INFO、ERROR）
     */
    private String levelString;
    /**
     * 线程名称
     */
    private String threadName;
    /**
     * 引用标志（预留字段，当前固定为0）
     */
    private Integer referenceFlag;
    /**
     * 日志参数0
     */
    private String arg0;
    /**
     * 日志参数1
     */
    private String arg1;
    /**
     * 日志参数2
     */
    private String arg2;
    /**
     * 日志参数3
     */
    private String arg3;
    /**
     * 调用者的文件名
     */
    private String callerFilename;
    /**
     * 调用者的类名
     */
    private String callerClass;
    /**
     * 调用者的方法名
     */
    private String callerMethod;
    /**
     * 调用者的行号
     */
    private String callerLine;
    /**
     * 事件ID，主键
     */
    private Long eventId;

    /**
     * 格式化的年月日
     */
    private String formattedTime;

    /**
     * 日志参数0列表
     */
    private List<String> arg0List;

    /**
     * 日期参数列表，250520
     */
    private List<String> logDateList;
}